score_add_mul <- function(beta,b.carr, b.phar, bandwidth, type, N, tau)
{
  udt <- sort(unique(b.phar$time))
  m1 <- table(b.phar$time)
  
  inteup <- c()
  ids <- unique(c(b.carr$id, b.phar$id))
  for (i in 1:length(ids))
  {
    inteup <- c(inteup, unique(b.carr$cent[which(b.carr$id==ids[i])]))
  }
  inteup <- sort(inteup)
  
  if (type == "kernel")
  {
    b.carr.sub <- b.carr[which(b.carr$time!=0),]
    bcarr.subz <- matrix(unlist(b.carr.sub[,c("id","time","z","cent")]),ncol=4)
    bcarr.subx <- matrix(unlist(b.carr.sub[,c("id","time","x","cent")]),ncol=4)
    s1.z.t <- function(t){
      if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz),dim=as.integer(nrow(bcarr.subz)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
      }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz),dim=as.integer(nrow(bcarr.subz)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
      } else {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz),dim=as.integer(nrow(bcarr.subz)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
      return(ker$ker[1])
    }
    bcarr.subx0 <- bcarr.subx
    bcarr.subx0[,3] <- exp(beta*bcarr.subx0[,3])
    s0.x.t <- function(t){
      if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx0),dim=as.integer(nrow(bcarr.subx0)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
      }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx0),dim=as.integer(nrow(bcarr.subx0)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
      } else {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx0),dim=as.integer(nrow(bcarr.subx0)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
      return(ker$ker[1])
    }
    bcarr.subx1 <- bcarr.subx
    bcarr.subx1[,3] <- bcarr.subx1[,3]*exp(beta*bcarr.subx1[,3])
    s1.x.t <- function(t){
      if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx1),dim=as.integer(nrow(bcarr.subx1)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
      }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx1),dim=as.integer(nrow(bcarr.subx1)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
      } else {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx1),dim=as.integer(nrow(bcarr.subx1)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
      return(ker$ker[1])
    }
    b.carr.subz2 <- b.carr.sub
    b.carr.subz2$z2 <- b.carr.subz2$z^2*exp(-beta*b.carr.subz2$x)
    bcarr.subz2 <- matrix(unlist(b.carr.subz2[,c("id","time","z2","cent")]),ncol=4)
    s2.z.t <- function(t){
      if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz2),dim=as.integer(nrow(bcarr.subz2)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
      }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz2),dim=as.integer(nrow(bcarr.subz2)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
      } else {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz2),dim=as.integer(nrow(bcarr.subz2)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
      return(ker$ker[1])
    }
    b.carr.subzx <- b.carr.sub
    b.carr.subzx$zx <- b.carr.subzx$z*b.carr.subzx$x
    bcarr.subzx <- matrix(unlist(b.carr.subzx[,c("id","time","zx","cent")]),ncol=4)
    s2.zx.t <- function(t){
      if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subzx),dim=as.integer(nrow(bcarr.subzx)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
      }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subzx),dim=as.integer(nrow(bcarr.subzx)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
      } else {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subzx),dim=as.integer(nrow(bcarr.subzx)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
      return(ker$ker[1])
    }
    #doesn't need s0 here since the denominator of the Nadaraya-Watson estimator is already s0 and ksmooth implements Nadaraya-Watson
    s1.z.t <- Vectorize(s1.z.t)
    s0.x.t <- Vectorize(s0.x.t)
    s1.x.t <- Vectorize(s1.x.t)
    s2.z.t <- Vectorize(s2.z.t)
    s2.zx.t <- Vectorize(s2.zx.t)
    
    part1.1 <- sum(b.phar$z*exp(-beta*b.phar$x)) - sum(s1.z.t(udt)[which(s0.x.t(udt)!=0)]/s0.x.t(udt)[which(s0.x.t(udt)!=0)] * m1[which(s0.x.t(udt)!=0)])
    part1.2 <- sum(b.phar$x) - sum(s1.x.t(udt)[which(s0.x.t(udt)!=0)]/s0.x.t(udt)[which(s0.x.t(udt)!=0)] * m1[which(s0.x.t(udt)!=0)])
    
    inte.f.11 <- function(t)    { 
      if (s0.x.t(t)!=0){
        u <- (s2.z.t(t) - s1.z.t(t)*s1.z.t(t)/s0.x.t(t))
      } else {
        u <- 0 }
      return(u)  }
    inte.f.22 <- function(t)    { 
      if (s0.x.t(t)!=0){
        u <- (s2.zx.t(t) - s1.z.t(t)*s1.x.t(t)/s0.x.t(t))
      } else {
        u <- 0 }
      return(u)  }
    inte.f.11 <- Vectorize(inte.f.11)
    inte.f.22 <- Vectorize(inte.f.22)
    
    intesum.11 <- (length(inteup))*integrate(f=inte.f.11, 0, inteup[1], subdivisions =30000L,stop.on.error = FALSE)$value
    intesum.22 <- (length(inteup))*integrate(f=inte.f.22, 0, inteup[1], subdivisions =30000L,stop.on.error = FALSE)$value
    for (i in 1:(length(inteup)-1))  {
      intesum.11 <- intesum.11 + (length(inteup)-i)*integrate(f=inte.f.11, inteup[i], inteup[i+1], subdivisions =30000L,stop.on.error = FALSE)$value
      intesum.22 <- intesum.22 + (length(inteup)-i)*integrate(f=inte.f.22, inteup[i], inteup[i+1], subdivisions =30000L,stop.on.error = FALSE)$value
    }
    
    score <- (part1.2*intesum.11 - intesum.22*part1.1)^2
    return(score)
  }    	
  
  if (type=="ACCF")
  {
    b.lccf <- genphar_two_am(carriage=b.carr, pharyn=b.phar, N=N, tau=tau)
    
    s1.z.t <- function(t, start=b.lccf$start, stop=b.lccf$stop, xx=b.lccf$z){
      mean(xx[t>=start & t<stop])}
    s0.x.t <- function(t, start=b.lccf$start, stop=b.lccf$stop, xx=exp(beta*b.lccf$x)){
      mean(xx[t>=start & t<stop])}
    s1.x.t <- function(t, start=b.lccf$start, stop=b.lccf$stop, xx=b.lccf$x*exp(beta*b.lccf$x)){
      mean(xx[t>=start & t<stop])}
    s2.z.t <- function(t, start=b.lccf$start, stop=b.lccf$stop, xx=b.lccf$z^2*exp(-beta*b.lccf$x)){
      mean(xx[t>=start & t<stop])}
    s2.zx.t <- function(t, start=b.lccf$start, stop=b.lccf$stop, xx=b.lccf$z*b.lccf$x){
      mean(xx[t>=start & t<stop])}
    
    #doesn't need s0 here since the denominator of the Nadaraya-Watson estimator is already s0 and ksmooth implements Nadaraya-Watson
    s1.z.t <- Vectorize(s1.z.t)
    s0.x.t <- Vectorize(s0.x.t)
    s1.x.t <- Vectorize(s1.x.t)
    s2.z.t <- Vectorize(s2.z.t)
    s2.zx.t <- Vectorize(s2.zx.t)
    
    part1.1 <- sum(b.phar$z*exp(-beta*b.phar$x)) - sum(s1.z.t(udt)[which(s0.x.t(udt)!=0)]/s0.x.t(udt)[which(s0.x.t(udt)!=0)] * m1[which(s0.x.t(udt)!=0)])
    part1.2 <- sum(b.phar$x) - sum(s1.x.t(udt)[which(s0.x.t(udt)!=0)]/s0.x.t(udt)[which(s0.x.t(udt)!=0)] * m1[which(s0.x.t(udt)!=0)])
    
    inte.f.11 <- function(t)    { 
      if (s0.x.t(t)!=0){
        u <- (s2.z.t(t) - s1.z.t(t)*s1.z.t(t)/s0.x.t(t))
      } else {
        u <- 0
      }
      return(u)  }
    inte.f.22 <- function(t)    { 
      if (s0.x.t(t)!=0){
        u <- (s2.zx.t(t) - s1.z.t(t)*s1.x.t(t)/s0.x.t(t))
      } else {
        u <- 0 
      }
      return(u)  }
    inte.f.11 <- Vectorize(inte.f.11)
    inte.f.22 <- Vectorize(inte.f.22)
    
    intesum.11 <- (length(inteup))*integrate(f=inte.f.11, 0, inteup[1], subdivisions =30000L,stop.on.error = FALSE)$value
    intesum.22 <- (length(inteup))*integrate(f=inte.f.22, 0, inteup[1], subdivisions =30000L,stop.on.error = FALSE)$value
    for (i in 1:(length(inteup)-1))  {
      intesum.11 <- intesum.11 + (length(inteup)-i)*integrate(f=inte.f.11, inteup[i], inteup[i+1], subdivisions =30000L,stop.on.error = FALSE)$value
      intesum.22 <- intesum.22 + (length(inteup)-i)*integrate(f=inte.f.22, inteup[i], inteup[i+1], subdivisions =30000L,stop.on.error = FALSE)$value
    }
    
    #part2.1 <- intesum.11*gamma
    #part2.2 <- intesum.22*gamma
    
    score <- (part1.2*intesum.11 - intesum.22*part1.1)^2
    #res <- (part1.1-part2.1)^2 + (part1.2-part2.2)^2
    #return(list(part1.1-part2.1,part1.2-part2.2))
    return(score)
  }
  
  if (type == "interp")
  {
    b.all <- rbind(b.phar, b.carr)
    b.all <- b.all[order(b.all[,2]),]
    b.all <- b.all[order(b.all[,1]),]
    #b.all <- b.all[which(!is.na(b.all$z1)),]
    
    s1.z.t <- function(t){
      b.all.sub <- b.all[which(b.all$cent >= t),]
      b.allsub <- matrix(unlist(b.all.sub[,c("id","time","z","cent")]),ncol=4)
      inter <- .Fortran("inter",ball=as.single(b.allsub),idall=as.single(unique(b.allsub[,1])),dim=as.integer(nrow(b.allsub)), length=as.integer(length(unique(b.allsub[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub[,1])))))
      out <- mean(inter$yinte)
      return(out)}
    s0.x.t <- function(t){
      b.all.sub <- b.all[which(b.all$cent >= t),]
      b.allsub <- matrix(unlist(b.all.sub[,c("id","time","x","cent")]),ncol=4)
      inter <- .Fortran("inter",ball=as.single(b.allsub),idall=as.single(unique(b.allsub[,1])),dim=as.integer(nrow(b.allsub)), length=as.integer(length(unique(b.allsub[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub[,1])))))
      out <- mean(exp(beta*inter$yinte), na.rm=TRUE)
      return(out)}
    s1.x.t <- function(t){
      b.all.sub <- b.all[which(b.all$cent >= t),]
      b.allsub <- matrix(unlist(b.all.sub[,c("id","time","x","cent")]),ncol=4)
      inter <- .Fortran("inter",ball=as.single(b.allsub),idall=as.single(unique(b.allsub[,1])),dim=as.integer(nrow(b.allsub)), length=as.integer(length(unique(b.allsub[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub[,1])))))
      out <- mean(inter$yinte*exp(beta*inter$yinte), na.rm=TRUE)
      return(out)}
    s2.z.t <- function(t){
      b.all.sub <- b.all[which(b.all$cent >= t),]
      b.allsub1 <- matrix(unlist(b.all.sub[,c("id","time","z","cent")]),ncol=4)
      inter1 <- .Fortran("inter",ball=as.single(b.allsub1),idall=as.single(unique(b.allsub1[,1])),dim=as.integer(nrow(b.allsub1)), length=as.integer(length(unique(b.allsub1[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub1[,1])))))
      b.allsub2 <- matrix(unlist(b.all.sub[,c("id","time","x","cent")]),ncol=4)
      inter2 <- .Fortran("inter",ball=as.single(b.allsub2),idall=as.single(unique(b.allsub2[,1])),dim=as.integer(nrow(b.allsub2)), length=as.integer(length(unique(b.allsub2[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub2[,1])))))
      out <- mean(inter1$yinte^2*exp(-beta*inter2$yinte), na.rm=TRUE)
      return(out)}
    s2.zx.t <- function(t){
      b.all.sub <- b.all[which(b.all$cent >= t),]
      b.allsub1 <- matrix(unlist(b.all.sub[,c("id","time","z","cent")]),ncol=4)
      inter1 <- .Fortran("inter",ball=as.single(b.allsub1),idall=as.single(unique(b.allsub1[,1])),dim=as.integer(nrow(b.allsub1)), length=as.integer(length(unique(b.allsub1[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub1[,1])))))
      b.allsub2 <- matrix(unlist(b.all.sub[,c("id","time","x","cent")]),ncol=4)
      inter2 <- .Fortran("inter",ball=as.single(b.allsub2),idall=as.single(unique(b.allsub2[,1])),dim=as.integer(nrow(b.allsub2)), length=as.integer(length(unique(b.allsub2[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub2[,1])))))
      out <- mean(inter1$yinte*inter2$yinte, na.rm=TRUE)
      return(out)}
    
    s1.z.t <- Vectorize(s1.z.t)
    s0.x.t <- Vectorize(s0.x.t)
    s1.x.t <- Vectorize(s1.x.t)
    s2.z.t <- Vectorize(s2.z.t)
    s2.zx.t <- Vectorize(s2.zx.t)
    
    part1.1 <- sum(b.phar$z*exp(-beta*b.phar$x)) - sum(s1.z.t(udt)[which(s0.x.t(udt)!=0)]/s0.x.t(udt)[which(s0.x.t(udt)!=0)] * m1[which(s0.x.t(udt)!=0)])
    part1.2 <- sum(b.phar$x) - sum(s1.x.t(udt)[which(s0.x.t(udt)!=0)]/s0.x.t(udt)[which(s0.x.t(udt)!=0)] * m1[which(s0.x.t(udt)!=0)])
    
    inte.f.11 <- function(t)    { 
      if (s0.x.t(t)!=0){
        u <- (s2.z.t(t) - s1.z.t(t)*s1.z.t(t)/s0.x.t(t))
      } else {
        u <- 0
      }
      return(u)  }
    inte.f.22 <- function(t)    { 
      if (s0.x.t(t)!=0){
        u <- (s2.zx.t(t) - s1.z.t(t)*s1.x.t(t)/s0.x.t(t))
      } else {
        u <- 0 
      }
      return(u)  }
    inte.f.11 <- Vectorize(inte.f.11)
    inte.f.22 <- Vectorize(inte.f.22)
    
    intesum.11 <- (length(inteup))*integrate(f=inte.f.11, 0, inteup[1], subdivisions =30000L,stop.on.error = FALSE)$value
    intesum.22 <- (length(inteup))*integrate(f=inte.f.22, 0, inteup[1], subdivisions =30000L,stop.on.error = FALSE)$value
    for (i in 1:(length(inteup)-1))  {
      intesum.11 <- intesum.11 + (length(inteup)-i)*integrate(f=inte.f.11, inteup[i], inteup[i+1], subdivisions =30000L,stop.on.error = FALSE)$value
      intesum.22 <- intesum.22 + (length(inteup)-i)*integrate(f=inte.f.22, inteup[i], inteup[i+1], subdivisions =30000L,stop.on.error = FALSE)$value
    }
    
    score <- (part1.2*intesum.11 - intesum.22*part1.1)^2
    return(score)
  }
}

est_add_mul <- function(b.carr, b.phar, bandwidth, type, N, tau)
{
  beta=optimize(f=score_add_mul, interval=c(-2,2),b.carr=b.carr, b.phar=b.phar, bandwidth=bandwidth, type=type, N=N, tau=tau)$minimum
  
  udt <- sort(unique(b.phar$time))
  m1 <- table(b.phar$time)
  
  inteup <- c()
  ids <- unique(c(b.carr$id, b.phar$id))
  for (i in 1:length(ids))
  {
    inteup <- c(inteup, unique(b.carr$cent[which(b.carr$id==ids[i])]))
  }
  inteup <- sort(inteup)
  
  if (type == "kernel")
  {
    b.carr.sub <- b.carr[which(b.carr$time!=0),]
    bcarr.subz <- matrix(unlist(b.carr.sub[,c("id","time","z","cent")]),ncol=4)
    bcarr.subx <- matrix(unlist(b.carr.sub[,c("id","time","x","cent")]),ncol=4)
    s1.z.t <- function(t){
      if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz),dim=as.integer(nrow(bcarr.subz)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
      }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz),dim=as.integer(nrow(bcarr.subz)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
      } else {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz),dim=as.integer(nrow(bcarr.subz)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
      return(ker$ker[1])
    }
    bcarr.subx0 <- bcarr.subx
    bcarr.subx0[,3] <- exp(beta*bcarr.subx0[,3])
    s0.x.t <- function(t){
      if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx0),dim=as.integer(nrow(bcarr.subx0)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
      }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx0),dim=as.integer(nrow(bcarr.subx0)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
      } else {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx0),dim=as.integer(nrow(bcarr.subx0)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
      return(ker$ker[1])
    }
    bcarr.subx1 <- bcarr.subx
    bcarr.subx1[,3] <- bcarr.subx1[,3]*exp(beta*bcarr.subx1[,3])
    s1.x.t <- function(t){
      if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx1),dim=as.integer(nrow(bcarr.subx1)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
      }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx1),dim=as.integer(nrow(bcarr.subx1)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
      } else {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx1),dim=as.integer(nrow(bcarr.subx1)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
      return(ker$ker[1])
    }
    b.carr.subz2 <- b.carr.sub
    b.carr.subz2$z2 <- b.carr.subz2$z^2*exp(-beta*b.carr.subz2$x)
    bcarr.subz2 <- matrix(unlist(b.carr.subz2[,c("id","time","z2","cent")]),ncol=4)
    s2.z.t <- function(t){
      if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz2),dim=as.integer(nrow(bcarr.subz2)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
      }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz2),dim=as.integer(nrow(bcarr.subz2)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
      } else {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz2),dim=as.integer(nrow(bcarr.subz2)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
      return(ker$ker[1])
    }
    b.carr.subzx <- b.carr.sub
    b.carr.subzx$zx <- b.carr.subzx$z*b.carr.subzx$x
    bcarr.subzx <- matrix(unlist(b.carr.subzx[,c("id","time","zx","cent")]),ncol=4)
    s2.zx.t <- function(t){
      if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subzx),dim=as.integer(nrow(bcarr.subzx)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
      }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subzx),dim=as.integer(nrow(bcarr.subzx)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
      } else {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subzx),dim=as.integer(nrow(bcarr.subzx)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
      return(ker$ker[1])
    }
    s1.z.t <- Vectorize(s1.z.t)
    s0.x.t <- Vectorize(s0.x.t)
    s1.x.t <- Vectorize(s1.x.t)
    s2.z.t <- Vectorize(s2.z.t)
    s2.zx.t <- Vectorize(s2.zx.t)
    
    part1.1 <- sum(b.phar$z*exp(-beta*b.phar$x)) - sum(s1.z.t(udt)[which(s0.x.t(udt)!=0)]/s0.x.t(udt)[which(s0.x.t(udt)!=0)] * m1[which(s0.x.t(udt)!=0)])
    
    inte.f.11 <- function(t)    { 
      if (s0.x.t(t)!=0){
        u <- (s2.z.t(t) - s1.z.t(t)*s1.z.t(t)/s0.x.t(t))
      } else {
        u <- 0 }
      return(u)  }
    inte.f.11 <- Vectorize(inte.f.11)
    
    intesum.11 <- (length(inteup))*integrate(f=inte.f.11, 0, inteup[1], subdivisions =30000L,stop.on.error = FALSE)$value
    for (i in 1:(length(inteup)-1))  {
      intesum.11 <- intesum.11 + (length(inteup)-i)*integrate(f=inte.f.11, inteup[i], inteup[i+1], subdivisions =30000L,stop.on.error = FALSE)$value
    }
    
    gamma <- part1.1/intesum.11
  }    	
  
  if (type=="ACCF")
  {
    b.lccf <- genphar_two_am(carriage=b.carr, pharyn=b.phar, N=N, tau=tau)
    
    s1.z.t <- function(t, start=b.lccf$start, stop=b.lccf$stop, xx=b.lccf$z){
      mean(xx[t>=start & t<stop])}
    s0.x.t <- function(t, start=b.lccf$start, stop=b.lccf$stop, xx=exp(beta*b.lccf$x)){
      mean(xx[t>=start & t<stop])}
    s1.x.t <- function(t, start=b.lccf$start, stop=b.lccf$stop, xx=b.lccf$x*exp(beta*b.lccf$x)){
      mean(xx[t>=start & t<stop])}
    s2.z.t <- function(t, start=b.lccf$start, stop=b.lccf$stop, xx=b.lccf$z^2*exp(-beta*b.lccf$x)){
      mean(xx[t>=start & t<stop])}
    s2.zx.t <- function(t, start=b.lccf$start, stop=b.lccf$stop, xx=b.lccf$z*b.lccf$x){
      mean(xx[t>=start & t<stop])}
    
    s1.z.t <- Vectorize(s1.z.t)
    s0.x.t <- Vectorize(s0.x.t)
    s1.x.t <- Vectorize(s1.x.t)
    s2.z.t <- Vectorize(s2.z.t)
    s2.zx.t <- Vectorize(s2.zx.t)
    
    part1.1 <- sum(b.phar$z*exp(-beta*b.phar$x)) - sum(s1.z.t(udt)[which(s0.x.t(udt)!=0)]/s0.x.t(udt)[which(s0.x.t(udt)!=0)] * m1[which(s0.x.t(udt)!=0)])
    
    inte.f.11 <- function(t)    { 
      if (s0.x.t(t)!=0){
        u <- (s2.z.t(t) - s1.z.t(t)*s1.z.t(t)/s0.x.t(t))
      } else {
        u <- 0
      }
      return(u)  }
    inte.f.11 <- Vectorize(inte.f.11)
    
    intesum.11 <- (length(inteup))*integrate(f=inte.f.11, 0, inteup[1], subdivisions =30000L,stop.on.error = FALSE)$value
    for (i in 1:(length(inteup)-1))  {
      intesum.11 <- intesum.11 + (length(inteup)-i)*integrate(f=inte.f.11, inteup[i], inteup[i+1], subdivisions =30000L,stop.on.error = FALSE)$value
    }
    
    gamma <- part1.1/intesum.11
  }
  
  if (type == "interp")
  {
    b.all <- rbind(b.phar, b.carr)
    b.all <- b.all[order(b.all[,2]),]
    b.all <- b.all[order(b.all[,1]),]
    #b.all <- b.all[which(!is.na(b.all$z1)),]
    
    s1.z.t <- function(t){
      b.all.sub <- b.all[which(b.all$cent >= t),]
      b.allsub <- matrix(unlist(b.all.sub[,c("id","time","z","cent")]),ncol=4)
      inter <- .Fortran("inter",ball=as.single(b.allsub),idall=as.single(unique(b.allsub[,1])),dim=as.integer(nrow(b.allsub)), length=as.integer(length(unique(b.allsub[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub[,1])))))
      out <- mean(inter$yinte)
      return(out)}
    s0.x.t <- function(t){
      b.all.sub <- b.all[which(b.all$cent >= t),]
      b.allsub <- matrix(unlist(b.all.sub[,c("id","time","x","cent")]),ncol=4)
      inter <- .Fortran("inter",ball=as.single(b.allsub),idall=as.single(unique(b.allsub[,1])),dim=as.integer(nrow(b.allsub)), length=as.integer(length(unique(b.allsub[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub[,1])))))
      out <- mean(exp(beta*inter$yinte), na.rm=TRUE)
      return(out)}
    s1.x.t <- function(t){
      b.all.sub <- b.all[which(b.all$cent >= t),]
      b.allsub <- matrix(unlist(b.all.sub[,c("id","time","x","cent")]),ncol=4)
      inter <- .Fortran("inter",ball=as.single(b.allsub),idall=as.single(unique(b.allsub[,1])),dim=as.integer(nrow(b.allsub)), length=as.integer(length(unique(b.allsub[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub[,1])))))
      out <- mean(inter$yinte*exp(beta*inter$yinte), na.rm=TRUE)
      return(out)}
    s2.z.t <- function(t){
      b.all.sub <- b.all[which(b.all$cent >= t),]
      b.allsub1 <- matrix(unlist(b.all.sub[,c("id","time","z","cent")]),ncol=4)
      inter1 <- .Fortran("inter",ball=as.single(b.allsub1),idall=as.single(unique(b.allsub1[,1])),dim=as.integer(nrow(b.allsub1)), length=as.integer(length(unique(b.allsub1[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub1[,1])))))
      b.allsub2 <- matrix(unlist(b.all.sub[,c("id","time","x","cent")]),ncol=4)
      inter2 <- .Fortran("inter",ball=as.single(b.allsub2),idall=as.single(unique(b.allsub2[,1])),dim=as.integer(nrow(b.allsub2)), length=as.integer(length(unique(b.allsub2[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub2[,1])))))
      out <- mean(inter1$yinte^2*exp(-beta*inter2$yinte), na.rm=TRUE)
      return(out)}
    s2.zx.t <- function(t){
      b.all.sub <- b.all[which(b.all$cent >= t),]
      b.allsub1 <- matrix(unlist(b.all.sub[,c("id","time","z","cent")]),ncol=4)
      inter1 <- .Fortran("inter",ball=as.single(b.allsub1),idall=as.single(unique(b.allsub1[,1])),dim=as.integer(nrow(b.allsub1)), length=as.integer(length(unique(b.allsub1[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub1[,1])))))
      b.allsub2 <- matrix(unlist(b.all.sub[,c("id","time","x","cent")]),ncol=4)
      inter2 <- .Fortran("inter",ball=as.single(b.allsub2),idall=as.single(unique(b.allsub2[,1])),dim=as.integer(nrow(b.allsub2)), length=as.integer(length(unique(b.allsub2[,1]))),t=as.single(t),tau=as.single(tau),yinte=as.single(rep(0,length(unique(b.allsub2[,1])))))
      out <- mean(inter1$yinte*inter2$yinte, na.rm=TRUE)
      return(out)}
    
    s1.z.t <- Vectorize(s1.z.t)
    s0.x.t <- Vectorize(s0.x.t)
    s1.x.t <- Vectorize(s1.x.t)
    s2.z.t <- Vectorize(s2.z.t)
    s2.zx.t <- Vectorize(s2.zx.t)
    
    part1.1 <- sum(b.phar$z*exp(-beta*b.phar$x)) - sum(s1.z.t(udt)[which(s0.x.t(udt)!=0)]/s0.x.t(udt)[which(s0.x.t(udt)!=0)] * m1[which(s0.x.t(udt)!=0)])
    
    inte.f.11 <- function(t)    { 
      if (s0.x.t(t)!=0){
        u <- (s2.z.t(t) - s1.z.t(t)*s1.z.t(t)/s0.x.t(t))
      } else {
        u <- 0
      }
      return(u)  }
    inte.f.11 <- Vectorize(inte.f.11)
    
    intesum.11 <- (length(inteup))*integrate(f=inte.f.11, 0, inteup[1], subdivisions =30000L,stop.on.error = FALSE)$value
    for (i in 1:(length(inteup)-1))  {
      intesum.11 <- intesum.11 + (length(inteup)-i)*integrate(f=inte.f.11, inteup[i], inteup[i+1], subdivisions =30000L,stop.on.error = FALSE)$value
    }
    
    gamma <- part1.1/intesum.11
  }    	
  
  return(c(beta,gamma))
}


select.con_add_mul <- function(b.carr, low, up,N,tau)
{
  s1.1.t.cv <- function(data,t,bandwidth){
    if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(data),dim=as.integer(nrow(data)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
    }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(data),dim=as.integer(nrow(data)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
    } else {ker <- .Fortran("kernel",bcarr=as.single(data),dim=as.integer(nrow(data)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
    return(ker$ker[1])
  }
  mse <- function(c,b.carr)
  {
    b.carr.sub <- b.carr[which(b.carr$time!=0),]
    cvsum <- 0
    idall <- unique(b.carr.sub$id)
    for (i in 1:length(idall))
    {
      del <- which(b.carr.sub$id==idall[i])
      if (length(del)>0) {
        for (k in 1:length(del))
        {
          datasub <- matrix(unlist(b.carr.sub[-del,c("id","time","z","cent")]),ncol=4)
          cvsum <- cvsum + (b.carr.sub[del[k],]$z-s1.1.t.cv(datasub,b.carr.sub[del[k],]$time,bandwidth=c*N^(-1/5)))^2
        }
      }
    }
    return(cvsum)
  }
  sel <- optimize(mse, interval=c(low,up),b.carr=b.carr)$minimum
  if (abs(sel-up) < 0.1) {
    up2 <- up
    while (abs(sel-up2) < 0.1)
    {
      up2 <- up+10
      sel <- optimize(mse, interval=c(up,up2),b.carr=b.carr)$minimum
      up <- up2
    }
  }
  return(sel)
}

boot_add_mul <- function(b.carr, b.phar, nb, bandwidth, type, N, tau)
{
  bootest <- NULL
  for (i in 1:nb){
    #print(i)
    boot.id <- sample(1:N, replace=T)
    b.carriage <- b.pharyn <- NULL
    for(k in 1:N){
      if(any(b.carr$id == boot.id[k]) ){
        foo <- b.carr[b.carr$id == boot.id[k],]  
        foo$id <-k
        b.carriage <- rbind( b.carriage, foo )
      }
      if(any(b.phar$id == boot.id[k]) ){     
        foo <- b.phar[b.phar$id == boot.id[k],]  
        foo$id <-k
        b.pharyn <- rbind( b.pharyn, foo )
      }
    }  
    bootest <- rbind(bootest, est_add_mul(b.carr=b.carriage, b.phar=b.pharyn, bandwidth=bandwidth, type=type, N=N, tau=tau))           
  }
  bootsd <- apply(bootest, 2, sd)
  return(c(bootsd))
}

base_add_mul <- function(t, beta, gamma, b.carr, b.phar, bandwidth, N, tau=NULL)
{
  idall <- unique(c(b.carr$id, b.phar$id))
  
  udt <- sort(unique(b.phar$time))
  m1 <- table(b.phar$time)
  gt <- function(t){
    sum(t <= unique(b.carr$cent))
  }
  gt <- Vectorize(gt)
  
  b.carr.sub <- b.carr[which(b.carr$time!=0),]
  bcarr.subz <- matrix(unlist(b.carr.sub[,c("id","time","z","cent")]),ncol=4)
  bcarr.subx <- matrix(unlist(b.carr.sub[,c("id","time","x","cent")]),ncol=4)
  s1.z.t <- function(t){
    if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz),dim=as.integer(nrow(bcarr.subz)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
    }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz),dim=as.integer(nrow(bcarr.subz)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
    } else {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subz),dim=as.integer(nrow(bcarr.subz)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
    return(ker$ker[1])
  }
  bcarr.subx0 <- bcarr.subx
  bcarr.subx0[,3] <- exp(beta*bcarr.subx0[,3])
  s0.x.t <- function(t){
    if (t < bandwidth) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx0),dim=as.integer(nrow(bcarr.subx0)),bandwidth=as.single(bandwidth),tt=as.single(bandwidth),ker=as.single(0))
    }  else if (t > (tau-bandwidth)) {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx0),dim=as.integer(nrow(bcarr.subx0)),bandwidth=as.single(bandwidth),tt=as.single(tau-bandwidth),ker=as.single(0))
    } else {ker <- .Fortran("kernel",bcarr=as.single(bcarr.subx0),dim=as.integer(nrow(bcarr.subx0)),bandwidth=as.single(bandwidth),tt=as.single(t),ker=as.single(0))}
    return(ker$ker[1])
  }   
  s1.z.t <- Vectorize(s1.z.t)
  s0.x.t <- Vectorize(s0.x.t)
  
  inte.f.i <- function(t)    {
    if (s0.x.t(t)!=0){
      u <- s1.z.t(t)/s0.x.t(t)
    } else {
      u <- 0 }
    return(u)  }
  inte.f.i <- Vectorize(inte.f.i)
  part1 <- integrate(f=inte.f.i, 0, t, subdivisions =30000L,stop.on.error = FALSE)$value
  
  udtsub <- sort(unique(b.phar[which(b.phar$time <= t),]$time))
  m1sub <- table(b.phar[which(b.phar$time <= t),]$time)
  baseline <- sum(1/s0.x.t(udtsub)[which(s0.x.t(udtsub)!=0)]/gt(udtsub)[which(s0.x.t(udtsub)!=0)]*m1sub[which(s0.x.t(udtsub)!=0)]) - part1 %*% gamma
  
  return(invisible(baseline))
}

